import math._

object BoundingBox {
  def apply(indexes: Traversable[Index]): BoundingBox = {
    val from = indexes.fold(Index.maxIndex)((index1, index2) =>
      Index(min(index1.i, index2.i), min(index1.j, index2.j), min(index1.k, index2.k)))
    val to = indexes.fold(Index.minIndex)((index1, index2) =>
      Index(max(index1.i, index2.i), max(index1.j, index2.j), max(index1.k, index2.k)))
    BoundingBox(from, to)
  }
}

case class BoundingBox(from: Index, to: Index) {
  def computeHaloWidth = max(from.computeHaloWidth, to.computeHaloWidth)
}
