/**
 * main class performing the optimization
 */
object Main {
  def main (args: Array[String]) {
    println("StellaOptimizer")
    println("===============\n")

    // parse optimization range argument
    val optimizationRange = try {
      (args(0).toInt, args(1).toInt)
    } catch { case e: Exception => (0, Int.MaxValue) }

    StellaExperiment1.runExperimentsCPU()
    StellaExperiment1.runExperimentsGPU()

    StellaExperiment2.runExperimentsCPU()
    StellaExperiment2.runExperimentsGPU()

    StellaExperiment3.runExperimentsCPU()
    StellaExperiment3.runExperimentsGPU()

    StellaExperiment4.runExperimentsCPU()
    StellaExperiment4.runExperimentsGPU()

//    // Experiment1 - Horizontal Diffusion
//    StellaExperiment1.runExperiment()
//    StellaExperiment1.performOptimizationCPU(optimizationRange)
//    StellaExperiment1.performOptimizationGPU(optimizationRange)
//
//    // Experiment2 - Fast Waves UV
//    StellaExperiment2.runExperiment()
//    StellaExperiment2.performOptimizationCPU(optimizationRange)
//    StellaExperiment2.performOptimizationGPU(optimizationRange)
//
//    // Experiment3 - Fast Waves Divergence
//    StellaExperiment3.runExperiment()
//    StellaExperiment3.performOptimizationCPU(optimizationRange)
//    StellaExperiment3.performOptimizationGPU(optimizationRange)

//    // Experiment4 - Fast Waves UV Divergence
//    StellaExperiment4.runExperiment()
//    StellaExperiment4.performOptimizationCPU(optimizationRange)
//    StellaExperiment4.performOptimizationGPU(optimizationRange)
  }
}
