/**
 * class representing a node of the kernel dependency graph
 */
trait Node {
  def id: String
  def inputs: List[String]
  def outputs: List[String]
  def stencils: List[Stencil]

  // compute an isl dependency map
  def dependencies: isl.UnionMap
  def flattenDependencies: isl.UnionMap

  def computeTilingImpl(parentOutputs: List[String], parentShifts: Map[String, List[Int]], parentTiling: isl.UnionMap, outputTiling: isl.UnionMap): List[(isl.UnionMap, isl.UnionMap)]
}
